package aufgabe01;

import java.io.InputStream;

import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.Property;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.Statement;
import com.hp.hpl.jena.rdf.model.StmtIterator;
import com.hp.hpl.jena.util.FileManager;

/**
 * Aufgabe 01
 * 
 * Beginnen Sie damit, dass Sie das vorher heruntergeladene Profil in ein
 * Speicherbasiertes Modell einlesen und dann ueber alle Statements (der Jena
 * Ausdruck für Triple) iterieren, um dann deren Subjekt, Praedikat und Objekt
 * auszugeben.
 * 
 */
public class Aufgabe01 {
	public static void main(String[] args) {
		// set input filename
		String inputFileName = "Asterix.rdf";

		// create an empty model
		Model model = ModelFactory.createDefaultModel();

		// use the FileManager to find the input file
		InputStream in = FileManager.get().open(inputFileName);

		if (in == null) {
			throw new IllegalArgumentException("File: " + inputFileName
					+ " not found");
		}

		// read the RDF/XML file
		model.read(in, null);

		// list the statements in the Model
		StmtIterator iter = model.listStatements();

		// print out the predicate, subject and object of each statement
		while (iter.hasNext()) {
			Statement stmt = iter.nextStatement(); // get next statement
			Resource subject = stmt.getSubject(); // get the subject
			Property predicate = stmt.getPredicate(); // get the predicate
			RDFNode object = stmt.getObject(); // get the object

			// filter annotations out
			if (!subject.isAnon()) {
				System.out.print("S: " + subject.toString() + " ");
				System.out.print("P: " + predicate.toString() + " ");
				System.out.print("O: " + object.toString() + "\n");
			}
		}
	}
}
