package aufgabe02;

import java.io.InputStream;

import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.Property;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.ResIterator;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.Statement;
import com.hp.hpl.jena.util.FileManager;
import com.hp.hpl.jena.vocabulary.RDF;

/**
 * Aufgabe 02
 * 
 * Erweitern Sie Ihr Programm derart, dass nur noch Triple ausgegeben werden,
 * die eine Person als Subjekt haben.
 * 
 */
public class Aufgabe02 {
	public static void main(String[] args) {
		// set input filename
		String inputFileName = "Asterix.rdf";
		// String inputFileName = "TimBernersLee.rdf";

		// create an empty model
		Model model = ModelFactory.createDefaultModel();

		// use the FileManager to find the input file
		InputStream in = FileManager.get().open(inputFileName);

		if (in == null) {
			throw new IllegalArgumentException("File: " + inputFileName
					+ " not found");
		}

		// read the RDF/XML file
		model.read(in, null);

		// get all resources of type foaf:Person
		Resource person = model.getResource("http://xmlns.com/foaf/0.1/Person");
		ResIterator iter = model.listSubjectsWithProperty(RDF.type, person);

		// for each person, show their foaf:name if known
		Property name = model.getProperty("http://xmlns.com/foaf/0.1/name");

		while (iter.hasNext()) {
			Resource subject = iter.nextResource(); // get subject
			Statement stmt = subject.getProperty(name);
			Property predicate = stmt.getPredicate(); // get predicate
			RDFNode object = stmt.getObject(); // get object

			// no need to filter annotation out this time
			System.out.print("S: " + subject.toString() + " ");
			System.out.print("P: " + predicate.toString() + " ");
			System.out.print("O: " + object.toString() + "\n");
		}
	}
}
