package aufgabe03;

import java.io.InputStream;
import java.net.URL;

import javax.swing.JOptionPane;

import com.hp.hpl.jena.rdf.model.Model;
import com.hp.hpl.jena.rdf.model.ModelFactory;
import com.hp.hpl.jena.rdf.model.Property;
import com.hp.hpl.jena.rdf.model.RDFNode;
import com.hp.hpl.jena.rdf.model.ResIterator;
import com.hp.hpl.jena.rdf.model.Resource;
import com.hp.hpl.jena.rdf.model.Statement;
import com.hp.hpl.jena.vocabulary.RDF;

/**
 * Aufgabe 03
 * 
 * Versuchen Sie auch, die Informationen von ihrer (oder einer beliebigen
 * anderen FOAF URL) anstatt direkt aus der lokalen Datei zu lesen.
 */
public class Aufgabe03 {
	public static void main(String[] args) {
		// get URL from popup window
		String urlString = JOptionPane.showInputDialog("Enter URL:",
				JOptionPane.OK_OPTION);

		// create an empty model
		Model model = ModelFactory.createDefaultModel();

		// data stream from url
		InputStream in = null;

		try {
			// try to get data stream from url

			// compose url and get stream
			URL location = new URL(urlString);
			in = location.openStream();

			if (in == null) {
				throw new IllegalArgumentException("URL: " + location
						+ " not found");
			}
		} catch (Exception e) {
			System.err.println("Failed to get RDF file from: " + urlString);
			System.exit(-1);
		}

		// read the RDF/XML file, add URL String 
		 // object to apply base URL to model
		model.read(in, urlString);
		 
		// get all resources of type foaf:Person
		Resource person = model.getResource("http://xmlns.com/foaf/0.1/Person");
		ResIterator iter = model.listSubjectsWithProperty(RDF.type, person);

		// for each person, show their foaf:name if known
		Property name = model.getProperty("http://xmlns.com/foaf/0.1/name");

		while (iter.hasNext()) {
			Resource subject = iter.nextResource(); // get subject
			Statement stmt = subject.getProperty(name);
			Property predicate = stmt.getPredicate(); // get predicate
			RDFNode object = stmt.getObject(); // get object

			// no need to filter annotation out this time
			System.out.print("S: " + subject.toString() + " ");
			System.out.print("P: " + predicate.toString() + " ");
			System.out.print("O: " + object.toString() + "\n");
		}
	}
}
